/*
 * Copyright (c) 2001-2004 MUSIC TECHNOLOGY GROUP (MTG)
 *                         UNIVERSITAT POMPEU FABRA
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

/*Specialization of Array for the case of an array of indeces. Adds function
reset to set elements to 0...size-1. See base class for more details.*/

#ifndef _IndexArray_
#define _IndexArray_

#include "Array.hxx"

namespace CLAM {

class IndexArray:public Array<TIndex>
{
public:
	IndexArray(int size=0)
	:Array<TIndex>(size) {
		SetSize(size);
		Reset();
	}
	void Reset(void)
	{
		for (int i=0;i<Size();i++)
		{
			GetPtr()[i]=i;
		}	
	}
};

}

#endif

